/*-
 * ~~~~~~licensing~~~~~~
 * events-api
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.core.events.jpa;

import ru.entaxy.esb.system.core.events.jpa.entity.EventTopic;

import java.util.List;
import java.util.Optional;

public interface EventTopicService {

    List<EventTopic> list();

    List<EventTopic> listByDeleted(boolean deleted);

    EventTopic get(long id);

    Optional<EventTopic> fetch(long id);

    EventTopic getByName(String name);

    Optional<EventTopic> fetchByName(String name);

    EventTopic getByNameAndDeleted(String name, boolean deleted);

    Optional<EventTopic> fetchByNameAndDeleted(String name, boolean deleted);

    EventTopic add(EventTopic eventTopic);

    EventTopic add(String name, String createdBy);

    EventTopic update(EventTopic eventTopic);

    EventTopic update(long id, String name, String editedBy);

    void remove(EventTopic eventTopic);

    void remove(long id);

    void markAsDeleted(long id, boolean deleted);

    int clean();

}
